Subject: Re: [PATCH net] net: vlan: sync VLAN features with lower device

From: Hangbin Liu <[email-masked]>
Date: Thu, 23 Oct 2025 14:17:56 +0000

On Thu, Oct 23, 2025 at 03:39:07PM +0200, Paolo Abeni wrote:
> On 10/21/25 11:56 AM, Hangbin Liu wrote:
> > After registering a VLAN device and setting its feature flags, we need to
> > synchronize the VLAN features with the lower device. For example, the VLAN
> > device does not have the NETIF_F_LRO flag, it should be synchronized with
> > the lower device based on the NETIF_F_UPPER_DISABLES definition.
> > 
> > As the dev->vlan_features has changed, we need to call
> > netdev_change_features(). The caller must run after netdev_upper_dev_link()
> > links the lower devices, so this patch adds the netdev_change_features()
> > call in register_vlan_dev().
> 
> 
> > 
> > Signed-off-by: Hangbin Liu <[email-masked]>
> > ---
> > 
> > I’m not sure what the proper Fixes tag should be, so I’ve left it blank for
> > now. If anyone has a clue, please let me know.
> 
> Apparently the issue is there since fd867d51f889aec11cca235ebb008578780d052d

Thanks, I thought it's a VLAN issue. Didn't expect it's from here.

> 
> > 
> > ---
> >  net/8021q/vlan.c | 2 ++
> >  1 file changed, 2 insertions(+)
> > 
> > diff --git a/net/8021q/vlan.c b/net/8021q/vlan.c
> > index fda3a80e9340..4857fb0ee11d 100644
> > --- a/net/8021q/vlan.c
> > +++ b/net/8021q/vlan.c
> > @@ -193,6 +193,8 @@ int register_vlan_dev(struct net_device *dev, struct netlink_ext_ack *extack)
> >  	vlan_group_set_device(grp, vlan->vlan_proto, vlan_id, dev);
> >  	grp->nr_vlan_devs++;
> >  
> > +	netdev_change_features(dev);
> 
> Is this just for NETIF_F_LRO? it feels a bit overkill for single flag.

Not only LRO, the vlan set all the dev features in vlan_dev_init() but doesn't
call the netdev_change_features(). I think it need to compute the dev features
once.

> Also, why netdev_change_features() (vs netdev_update_features())?> +

Hmm, I might made a mistake. I thought any_dev->vlan_features changes need
to call netdev_change_features(). But actually only the lower_dev->vlan_features
changes need to call netdev_change_features(). I will fix it.

Thanks
Hangbin